class Display

Same name and namespace in other branches
  1. 11.x core/modules/views_ui/src/Form/Ajax/Display.php \Drupal\views_ui\Form\Ajax\Display
  2. 10 core/modules/views_ui/src/Form/Ajax/Display.php \Drupal\views_ui\Form\Ajax\Display
  3. 9 core/modules/views_ui/src/Form/Ajax/Display.php \Drupal\views_ui\Form\Ajax\Display
  4. 8.9.x core/modules/views_ui/src/Form/Ajax/Display.php \Drupal\views_ui\Form\Ajax\Display

Provides a form for editing the Views display.

@internal

Hierarchy

Expanded class hierarchy of Display

93 string references to 'Display'
AddComponentTest::testAddComponent in core/modules/layout_builder/tests/src/Kernel/Plugin/ConfigAction/AddComponentTest.php
Tests adding a component to a view display using a config action.
AddComponentTest::testAddComponentToEmptyRegionThatIsNotFirst in core/modules/layout_builder/tests/src/Kernel/Plugin/ConfigAction/AddComponentTest.php
Tests that adding a component to another section works as expected.
Attachment::buildOptionsForm in core/modules/views/src/Plugin/views/display/Attachment.php
Provide the default form for setting options.
BasicTest::testWizardDefaultValues in core/modules/views/tests/src/Functional/Wizard/BasicTest.php
Tests default plugin values are populated from the wizard form.
ClaroHooks::fileAndImageWidgetHelper in core/themes/claro/src/Hook/ClaroHooks.php
Helper pre-process callback for file_managed_file and image_widget.

... See full list

File

core/modules/views_ui/src/Form/Ajax/Display.php, line 13

Namespace

Drupal\views_ui\Form\Ajax
View source
class Display extends ViewsFormBase {
  
  /**
   * Constructs a new Display object.
   */
  public function __construct($type = NULL) {
    $this->setType($type);
  }
  
  /**
   * {@inheritdoc}
   */
  public function getFormKey() {
    return 'display';
  }
  
  /**
   * {@inheritdoc}
   *
   * @todo Remove this and switch all usage of $form_state->get('section') to
   *   $form_state->get('type').
   */
  public function getFormState(ViewEntityInterface $view, $display_id, $js) {
    $form_state = parent::getFormState($view, $display_id, $js);
    $form_state->set('section', $this->type);
    return $form_state;
  }
  
  /**
   * {@inheritdoc}
   */
  public function getForm(ViewEntityInterface $view, $display_id, $js, $type = NULL) {
    $this->setType($type);
    return parent::getForm($view, $display_id, $js);
  }
  
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'views_ui_edit_display_form';
  }
  
  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $view = $form_state->get('view');
    $display_id = $form_state->get('display_id');
    $executable = $view->getExecutable();
    if (!$executable->setDisplay($display_id)) {
      $form['markup'] = [
        '#markup' => $this->t('Invalid display id @display', [
          '@display' => $display_id,
        ]),
      ];
      return $form;
    }
    // Get form from the handler.
    $form['options'] = [
      '#theme_wrappers' => [
        'container',
      ],
      '#attributes' => [
        'class' => [
          'scroll',
        ],
        'data-drupal-views-scroll' => TRUE,
      ],
    ];
    $executable->display_handler
      ->buildOptionsForm($form['options'], $form_state);
    // The handler options form sets $form['#title'], which we need on the
    // entire $form instead of just the ['options'] section.
    $form['#title'] = $form['options']['#title'];
    unset($form['options']['#title']);
    // Move the override dropdown out of the scrollable section of the form.
    if (isset($form['options']['override'])) {
      $form['override'] = $form['options']['override'];
      unset($form['options']['override']);
    }
    $name = $form_state->get('update_name');
    $view->getStandardButtons($form, $form_state, 'views_ui_edit_display_form', $name);
    return $form;
  }
  
  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    $view = $form_state->get('view');
    $display_id = $form_state->get('display_id');
    $view->getExecutable()->displayHandlers
      ->get($display_id)
      ->validateOptionsForm($form['options'], $form_state);
    if ($form_state->getErrors()) {
      // Trigger a form rerender so error messages are displayed correctly in
      // the AJAX modal.
      // @see \Drupal\views_ui\Form\Ajax\ViewsFormBase::ajaxFormWrapper()
      $form_state->set('rerender', TRUE);
    }
  }
  
  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $view = $form_state->get('view');
    $display_id = $form_state->get('display_id');
    $view->getExecutable()->displayHandlers
      ->get($display_id)
      ->submitOptionsForm($form['options'], $form_state);
    $view->cacheSet();
  }

}

Members

Title Sort descending Modifiers Object type Summary Overriden Title Overrides
AutowiredInstanceTrait::createInstanceAutowired public static function Instantiates a new instance of the implementing class using autowiring.
AutowiredInstanceTrait::getAutowireArguments private static function Resolves arguments for a method using autowiring.
AutowireTrait::create public static function Instantiates a new instance of the implementing class using autowiring. 131
DependencySerializationTrait::$_entityStorages protected property An array of entity type IDs keyed by the property name of their storages.
DependencySerializationTrait::$_serviceIds protected property An array of service IDs keyed by property name used for serialization.
DependencySerializationTrait::__sleep public function 2
DependencySerializationTrait::__wakeup public function 2
Display::buildForm public function Form constructor. Overrides FormInterface::buildForm
Display::getForm public function Creates a new instance of this form. Overrides ViewsFormBase::getForm
Display::getFormId public function Returns a unique string identifying the form. Overrides FormInterface::getFormId
Display::getFormKey public function Returns the key that represents this form. Overrides ViewsFormInterface::getFormKey
Display::getFormState public function @todo Remove this and switch all usage of $form_state->get('section') to
$form_state->get('type').
Overrides ViewsFormBase::getFormState
Display::submitForm public function Form submission handler. Overrides ViewsFormBase::submitForm
Display::validateForm public function Form validation handler. Overrides ViewsFormBase::validateForm
Display::__construct public function Constructs a new Display object.
FormBase::$configFactory protected property The config factory. 1
FormBase::$requestStack protected property The request stack. 1
FormBase::$routeMatch protected property The route match.
FormBase::config protected function Retrieves a configuration object.
FormBase::configFactory protected function Gets the config factory for this form. 1
FormBase::container private function Returns the service container.
FormBase::currentUser protected function Gets the current user. 2
FormBase::getRequest protected function Gets the request object. Overrides HtmxRequestInfoTrait::getRequest
FormBase::getRouteMatch protected function Gets the route match.
FormBase::logger protected function Gets the logger for a specific channel.
FormBase::redirect protected function Returns a redirect response object for the specified route.
FormBase::resetConfigFactory public function Resets the configuration factory.
FormBase::setConfigFactory public function Sets the config factory for this form.
FormBase::setRequestStack public function Sets the request stack object to use.
HtmxRequestInfoTrait::getHtmxCurrentUrl protected function Retrieves the URL of the requesting page from an HTMX request header.
HtmxRequestInfoTrait::getHtmxPrompt protected function Retrieves the prompt from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTarget protected function Retrieves the target identifier from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTrigger protected function Retrieves the trigger identifier from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTriggerName protected function Retrieves the trigger name from an HTMX request header.
HtmxRequestInfoTrait::isHtmxBoosted protected function Determines if the request is boosted by HTMX.
HtmxRequestInfoTrait::isHtmxHistoryRestoration protected function Determines if if the request is for history restoration.
HtmxRequestInfoTrait::isHtmxRequest protected function Determines if the request is sent by HTMX.
LoggerChannelTrait::$loggerFactory protected property The logger channel factory service.
LoggerChannelTrait::getLogger protected function Gets the logger for a specific channel.
LoggerChannelTrait::setLoggerFactory public function Injects the logger channel factory.
MessengerTrait::$messenger protected property The messenger. 26
MessengerTrait::messenger public function Gets the messenger. 26
MessengerTrait::setMessenger public function Sets the messenger.
RedirectDestinationTrait::$redirectDestination protected property The redirect destination service. 2
RedirectDestinationTrait::getDestinationArray protected function Prepares a 'destination' URL query parameter for use with \Drupal\Core\Url.
RedirectDestinationTrait::getRedirectDestination protected function Returns the redirect destination service.
RedirectDestinationTrait::setRedirectDestination public function Sets the redirect destination service.
StringTranslationTrait::$stringTranslation protected property The string translation service. 3
StringTranslationTrait::formatPlural protected function Formats a string containing a count of items.
StringTranslationTrait::getNumberOfPlurals protected function Returns the number of plurals supported by a given language.
StringTranslationTrait::getStringTranslation protected function Gets the string translation service.
StringTranslationTrait::setStringTranslation public function Sets the string translation service to use. 2
StringTranslationTrait::t protected function Translates a string to the current language or to a given language. 1
ViewsFormBase::$id protected property The ID of the item this form is manipulating.
ViewsFormBase::$type protected property The type of item this form is manipulating.
ViewsFormBase::ajaxFormWrapper protected function Wrapper for handling AJAX forms.
ViewsFormBase::setID protected function Sets the ID for this form.
ViewsFormBase::setType protected function Sets the type for this form.
ViewsFormHelperTrait::buildFormUrl protected function Creates the menu path for a standard AJAX form given the form state.
ViewsFormHelperTrait::formButtonWasClicked public static function The #process callback for a button.
ViewsFormHelperTrait::getConfigFactory protected function Returns the config factory service.
ViewsFormHelperTrait::standardDisplayDropdown protected function Adds an element to select either the default or the current display.

Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.